;
;	afxctrl.ahk: Helper library for AutoHotkey to control Afx without custom key configuration
;
;		Copyright (c) Yak! 2007 All rights reserved.
;
;	$URL: https://yak.myhome.cx/repos/source/afxscrpt/trunk/afxctrl.ahk $
;	$Date: 2009-12-06 12:56:58 +0900 (Sun, 06 Dec 2009) $
;	$Rev: 962 $
;

#Include win32.ahk

;
; ȉAKvȂ΁uӁvƁuӂvʂuӁvƕ\LB
;

;
; General functions
;

; AfxWindow:  hwnd ݂A 0 ȊȌꍇ͑Ώ
;            EBhEnh hwnd ɐݒ肷B
;            ɂ炸ΏۃEBhẼnhԂB
;            ΏۃEBhEݒ̏ꍇ AfxFindWindow(0) 
;            ߂l(őOʂ́uӁv)𑀍ΏۃEBhEɐݒ肷B
AfxWindow(hwnd = 0)
{
	static TargetWindow = 0
	If hwnd
	{
		TargetWindow:=hwnd
	}
	If TargetWindow = 0
	{
		TargetWindow:=AfxFindWindow(0)
	}
	return TargetWindow
}

_AfxFindWindow(class, arg = 0)
{
	If arg
	{
		If(arg == "1st" || arg == "1)")
		{
			Backup:=A_TitleMatchMode
			SetTitleMatchMode, 2
			Bakcup_DHW:=A_DetectHiddenWindows
			DetectHiddenWindows, On
			WinGet, IDs, List, ahk_class %class%, , th.
			DetectHiddenWindows, %Backup_DHW%
			SetTitleMatchMode, %Backup%
			Loop, %IDs%
			{
				ID:=IDs%A_Index%
				WinGetTitle, Title, ahk_id %ID%
				If(!InStr(Title, "2nd.", true) && !InStr(Title, "3rd.") && (Asc(Title)<Asc("1") || Asc(Title)>Asc("9")))
				{
					AfxWindow(ID)
					return ID
				}
			}
		} else {
			Backup:=A_TitleMatchMode
			SetTitleMatchMode, 2
			Bakcup_DHW:=A_DetectHiddenWindows
			DetectHiddenWindows, On
			WinGet, hwnd, ID, %arg% ahk_class %class%
			DetectHiddenWindows, %Backup_DHW%
			SetTitleMatchMode, %Backup%
			If hwnd
			{
				AfxWindow(hwnd)
				return hwnd
			}
		}
	} else {
		Bakcup_DHW:=A_DetectHiddenWindows
		DetectHiddenWindows, On
		WinGet, hwnd, ID, ahk_class %class%
		DetectHiddenWindows, %Backup_DHW%
		If hwnd
		{
			AfxWindow(hwnd)
			return hwnd
		}
	}
	return 0
}

_AfxFindEnumWindowsProc(hwnd, lParam)
{
	global _AfxFindEnumWindowsProcOutput
	win1 := NumGet(lParam+0, 0)
	win2 := NumGet(lParam+0, 4)
	If hwnd = %win1%
	{
		_AfxFindEnumWindowsProcOutput := win1
		return 0
	}
	If hwnd = %win2%
	{
		_AfxFindEnumWindowsProcOutput := win2
		return 0
	}
	return 1
}

_AfxFindWindowSelect(win1, win2)
{
	global _AfxFindEnumWindowsProcOutput
	global _AfxFindEnumWindowsProcAddress

	If win1 = 0
	{
		If win2 = 0
		{
			return 0
		}
		Else
		{
			return win2
		}
	}
	Else
	{
		If win2 = 0
		{
			return win1
		}
		Else
		{
			If not _AfxFindEnumWindowsProcAddress
			    _AfxFindEnumWindowsProcAddress := RegisterCallback("_AfxFindEnumWindowsProc", "Fast")
			_AfxFindEnumWindowsProcOutput = 0
			VarSetCapacity(Arg, 8)
			NumPut(win1, Arg, 0, "UInt")
			NumPut(win2, Arg, 4, "UInt")
			DllCall("EnumWindows", "UInt", _AfxFindEnumWindowsProcAddress, "UInt", &Arg)
			return _AfxFindEnumWindowsProcOutput
		}
	}
}

; AfxFindWindow: Ȃ or  0 ̏ꍇ͍őOʂ́uӁv
;                EBhEnhԂB
;                2ɂāuӁv邢́uӂv̂
;                ΏۂƂ邩w肷B
;                l̈Ӗ́A0:A1:uӂv̂݁A2:uӁv̂݁B
;                ȗ͗B
;                1 1st ̏ꍇ͖́uӁṽEBhEnhԂ
;                ȊO̓EBhE^Cg arg ܂ށuӁv
;                EBhEnhԂB
;                EBhEnh AfxWindow ĂяoƂɂ
;                ΏۃEBhEnhƂĐݒ肷B
AfxFindWindow(arg = 0, type = 0)
{
	If type = 0
	{
		win1 := _AfxFindWindow("TAfxWForm", arg)
		win2 := _AfxFindWindow("TAfxForm", arg)
		return _AfxFindWindowSelect(win1, win2)
	}
	Else If type = 1
	{
		return _AfxFindWindow("TAfxWForm", arg)
	}
	Else If type = 2
	{
		return _AfxFindWindow("TAfxForm", arg)
	}
	return 0
}
AfxFindWindowExec(arg = 0, type = 0)
{
	return GetWindowExecFileName(AfxFindWindow(arg, type))
}

; AfxFixArg1: ֐B1 ֐̈ȗ̐ݒsB
;             ȗĂꍇ(0)́AAfxWindow(0) ĂяoA
;             ݂̑ΏۃEBhE擾B
AfxFixArg1(ByRef hwnd)
{
	If hwnd {
	} else {
		hwnd:=AfxWindow(0)
	}
}

; AfxFixArg2: ֐B2 ֐̈ȗ̐ݒsB
;             1 ݂̂nꂽꍇ( 2  0)A
;              1  2 Ƃ݂ȂA 1 ɂ AfxWindow(0)
;             (ΏۃEBhE)pB
;             2 nꂽꍇŁA 1  0 ̏ꍇ́A
;              1  AfxWindow(0)(ΏۃEBhE)pB
AfxFixArg2(ByRef hwnd, ByRef arg, default = 0)
{
	If arg <> %default%
	{
		If hwnd {
		} else {
			hwnd:=AfxWindow(0)
		}
	} else {
		arg:=hwnd
		hwnd:=AfxWindow(0)
	}
}

AfxFixArg3(ByRef hwnd, ByRef arg, ByRef arg2, default = 0)
{
	If arg2 <> %default%
	{
		If hwnd {
		} else {
			hwnd:=AfxWindow(0)
		}
	} else {
		arg2:=arg
		arg:=hwnd
		hwnd:=AfxWindow(0)
	}
}

AfxSendKey(hwnd, key = 0)
{
	AfxFixArg2(hwnd, key)
	WM_KEYDOWN=256
	WM_KEYUP=257
	WM_SYSKEYDOWN=260
	WM_SYSKEYUP=261

	Modifier := SubStr(key, 1, 1)
	VKey := SubStr(key, 2, 3)

	AltState := GetKeyState("Alt")
	ControlState := GetKeyState("Control")
	ShiftState := GetKeyState("Shift")

	If ((Modifier & 1) && !ShiftState)
		Send {Shift Down}
	If (!(Modifier & 1) && ShiftState)
		Send {Shift Up}
	If ((Modifier & 2) && !ControlState)
		Send {Control Down}
	If (!(Modifier & 2) && ControlState)
		Send {Control Up}

	If (Modifier & 4) {
		SendMessage, %WM_SYSKEYDOWN%, %VKey%, 0x20000001, , ahk_id %hwnd%
		SendMessage, %WM_SYSKEYUP%, %VKey%, 0xE0000001, , ahk_id %hwnd%
	} Else {
		SendMessage, %WM_KEYDOWN%, %VKey%, 1, , ahk_id %hwnd%
		SendMessage, %WM_KEYUP%, %VKey%, 0xC0000001, , ahk_id %hwnd%
	}

	If ((Modifier & 1) && !ShiftState)
		Send {Shift Up}
	If (!(Modifier & 1) && ShiftState)
		Send {Shift Down}
	If ((Modifier & 2) && !ControlState)
		Send {Control Up}
	If (!(Modifier & 2) && ControlState)
		Send {Control Down}
}
AfxCommand(hwnd, str = 0)
{
	AfxFixArg2(hwnd, str)
	message:=RegisterWindowMessage("Afx_CD_Message_ID_AKT")
	atom:=GlobalAddAtom(str)
	PostMessage, %message%, 1, %atom%, , ahk_id %hwnd%
}

AfxGetPWin(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetFocus, control, ahk_id %hwnd%
	If control = TFileBox1
		return "L"
	Else If control = TFileBox2
		return "R"
	return
}

AfxGetOWin(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetFocus, control, ahk_id %hwnd%
	If control = TFileBox1
		return "R"
	Else If control = TFileBox2
		return "L"
	return
}

;
; Status bar
;

AfxGetStatusBarTextLength(hwnd, part = -1)
{
	global SB_GETTEXTLENGTHA

	AfxFixArg2(hwnd, part, -1)
	SendMessage, %SB_GETTEXTLENGTHA%, %part%, 0, TStatusBar1, ahk_id %hwnd%
	return ErrorLevel & 0xFFFF
}

AfxGetStatusBarTextType(hwnd, part = -1)
{
	global SB_GETTEXTLENGTHA

	AfxFixArg2(hwnd, part, -1)
	SendMessage, %SB_GETTEXTLENGTHA%, %part%, 0, TStatusBar1, ahk_id %hwnd%
	return (ErrorLevel >> 16) & 0xFFFF
}

AfxGetStatusBarText(hwnd, part = -1)
{
	global SB_GETTEXTA

	AfxFixArg2(hwnd, part, -1)
	len:=AfxGetStatusBarTextLength(hwnd, part)
	address:=AllocWinMemReceive(hwnd, len)
	SendMessage, %SB_GETTEXTA%, %part%, %address%, TStatusBar1, ahk_id %hwnd%
	result:=ReadWinMem(hwnd, address, len)
	FreeWinMem(hwnd, address)
	return result
}

AfxSetStatusBarText(hwnd, part, content = 0, type = -1)
{
	global SB_SETTEXTA, SBT_NOBORDERS, SBT_NORMAL
	If content {
		If type = -1
		{
			type:=content
			content:=part
			part:=hwnd
			hwnd:=AfxWindow(0)
		}
	} Else {
		content:=part
		part:=hwnd
		hwnd:=AfxWindow(0)
	}
	If type = -1
		If part = 0
			type:=SBT_NOBORDERS
		Else If part = 2
			type:=SBT_NORMAL

	address:=AllocWinMemSend(hwnd, content, true)
	SendMessage, %SB_SETTEXTA%, % type | part, %address%, TStatusBar1, ahk_id %hwnd%
	FreeWinMem(hwnd, address)
}

;
; File window
;

AfxGetLCount(hwnd = 0)
{
	global LB_GETCOUNT

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETCOUNT%, 0, 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetRCount(hwnd = 0)
{
	global LB_GETCOUNT

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETCOUNT%, 0, 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetLCursorIndex(hwnd = 0)
{
	global LB_GETCARETINDEX

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETCARETINDEX%, 0, 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetRCursorIndex(hwnd = 0)
{
	global LB_GETCARETINDEX

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETCARETINDEX%, 0, 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxSetLCursorIndex(hwnd, index = -1, partial = -1)
{
	global LB_SETCARETINDEX

	If index = -1
	{
		index:=hwnd
		hwnd:=AfxWindow(0)
		partial=false
	} Else If(partial = -1) {
		index:=hwnd
		partial:=index
		hwnd:=AfxWindow(0)
	}
	SendMessage, %LB_SETCARETINDEX%, %index%, % partial ? 1 : 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxSetRCursorIndex(hwnd, index = -1, partial = -1)
{
	global LB_SETCARETINDEX

	If index = -1
	{
		index:=hwnd
		hwnd:=AfxWindow(0)
		partial=false
	} Else If(partial = -1) {
		index:=hwnd
		partial:=index
		hwnd:=AfxWindow(0)
	}
	SendMessage, %LB_SETCARETINDEX%, %index%, % partial ? 1 : 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetLSelectCount(hwnd = 0)
{
	global LB_GETSELCOUNT

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETSELCOUNT%, 0, 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetRSelectCount(hwnd = 0)
{
	global LB_GETSELCOUNT

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETSELCOUNT%, 0, 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetLTopIndex(hwnd = 0)
{
	global LB_GETTOPINDEX

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETTOPINDEX%, 0, 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetRTopIndex(hwnd = 0)
{
	global LB_GETTOPINDEX

	AfxFixArg1(hwnd)
	SendMessage, %LB_GETTOPINDEX%, 0, 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxSetLTopIndex(hwnd, index = -1)
{
	global LB_SETTOPINDEX

	AfxFixArg2(hwnd, index, -1)
	SendMessage, %LB_SETTOPINDEX%, %index%, 0, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxSetRTopIndex(hwnd, index = -1)
{
	global LB_SETTOPINDEX

	AfxFixArg2(hwnd, index, -1)
	SendMessage, %LB_SETTOPINDEX%, %index%, 0, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetLItemFromPoint(hwnd, x, y = -1)
{
	global LB_ITEMFROMPOINT

	AfxFixArg3(hwnd, x, y, -1)
	SendMessage, %LB_ITEMFROMPOINT%, 0, % (y << 16) + x, TFileBox1, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetRItemFromPoint(hwnd, x, y = -1)
{
	global LB_ITEMFROMPOINT

	AfxFixArg3(hwnd, x, y, -1)
	SendMessage, %LB_ITEMFROMPOINT%, 0, % (y << 16) + x, TFileBox2, ahk_id %hwnd%
	return %ErrorLevel%
}

AfxGetLRows(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetPos, , , w, h, TFileBox1, ahk_id %hwnd%
	top:=AfxGetLItemFromPoint(hwnd, 0, 0)
	bottom:=AfxGetLItemFromPoint(hwnd, w, h) & 0xFFFF
	return bottom - top + 1
}

AfxGetRRows(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetPos, , , w, h, TFileBox2, ahk_id %hwnd%
	top:=AfxGetRItemFromPoint(hwnd, 0, 0)
	bottom:=AfxGetRItemFromPoint(hwnd, w, h) & 0xFFFF
	return bottom - top + 1
}

AfxSelectLRange(hwnd, from, to = 0)
{
	global LB_SELITEMRANGEEX

	AfxFixArg3(hwnd, from, to)
	SendMessage, %LB_SELITEMRANGEEX%, %from%, %to%, TFileBox1, ahk_id %hwnd%
}

AfxSelectRRange(hwnd, from, to = 0)
{
	global LB_SELITEMRANGEEX

	AfxFixArg3(hwnd, from, to)
	SendMessage, %LB_SELITEMRANGEEX%, %from%, %to%, TFileBox2, ahk_id %hwnd%
}

AfxDeselectLRange(hwnd, from, to = 0)
{
	global LB_SELITEMRANGE

	AfxFixArg3(hwnd, from, to)
	lp:=((from & 0xFFFF) << 16) + (to & 0xFFFF)
	SendMessage, %LB_SELITEMRANGE%, 0, %lp%, TFileBox1, ahk_id %hwnd%
}

AfxDeselectRRange(hwnd, from, to = 0)
{
	global LB_SELITEMRANGE

	AfxFixArg3(hwnd, from, to)
	lp:=((from & 0xFFFF) << 16) + (to & 0xFFFF)
	SendMessage, %LB_SELITEMRANGE%, 0, %lp%, TFileBox2, ahk_id %hwnd%
}

;
; Status information
;

; Getter

AfxGetLPathInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel2, ahk_id %hwnd%
	return text
}

AfxGetRPathInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel6, ahk_id %hwnd%
	return text
}

AfxGetLMarkInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel3, ahk_id %hwnd%
	return text
}

AfxUpdateLMarkInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlClick, TFileBox1, ahk_id %hwnd%
}

AfxGetRMarkInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel7, ahk_id %hwnd%
	return text
}

AfxUpdateRMarkInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlClick, TFileBox2, ahk_id %hwnd%
}

AfxGetLSizeInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel4, ahk_id %hwnd%
	return text
}

AfxGetRSizeInfo(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ControlGetText, text, TPanel8, ahk_id %hwnd%
	return text
}

; general helper

AfxSizeStr2Size(str)
{
	RegExMatch(str, "(\d*\.\d+)([KMGT]?)B", result)
	If result1
	{
		If result2 = K
			factor=1024
		Else If result2 = M
			factor:=1024*1024
		Else If result2 = G
			factor:=1024*1024*1024
		Else If result2 = T
			factor:=1024*1024*1024*1024
		Else
			factor=1
		return Floor(result1 * factor)
	}
	Else
		return
}

; mark info helper

AfxMarkInfo2Volume(str)
{
	RegExMatch(str, "^(.*?\S)\s*(\d|$)", result)
	return result1
}

AfxMarkInfo2DirNum(str)
{
	RegExMatch(str, "^.*\D(\d+)\s*Dir(s?).*Marked", result)
	return result1
}

AfxMarkInfo2FileNum(str)
{
	RegExMatch(str, "^.*\D(\d+)\s*File(s?).*Marked", result)
	return result1
}

AfxMarkInfo2SizeStr(str)
{
	RegExMatch(str, "^.*\D(\d*\.\d+)\s*([KMGT]?B).*Marked", result)
	return result1 . result2
}

AfxMarkInfo2Size(str)
{
	return AfxSizeStr2Size(AfxMarkInfo2SizeStr(str))
}

; size info helper

AfxSizeInfo2DirNum(str)
{
	RegExMatch(str, "(\d+)\s*Dir", result)
	return result1
}

AfxSizeInfo2FileNum(str)
{
	RegExMatch(str, "(\d+)\s*File", result)
	return result1
}

AfxSizeInfo2MaxDiskStr(str) 
{
	RegExMatch(str, "(\d*\.\d+)\s*([KMGT]?B)\s*\(", result)
	return result1 . result2
}

AfxSizeInfo2MaxDisk(str)
{
	return AfxSizeStr2Size(AfxSizeInfo2MaxDiskStr(str))
}

AfxSizeInfo2AvailDiskStr(str)
{
	RegExMatch(str, "\(\s*(\d*\.\d+)\s*([KMGT]?B)\s*\)", result)
	return result1 . result2
}

AfxSizeInfo2AvailDisk(str)
{
	return AfxSizeStr2Size(AfxSizeInfo2AvailDiskStr(str))
}

_AfxGetMessageWindow(hwnd = 0)
{
	AfxFixArg1(hwnd)
	ww = 0
	Loop {
		ControlGet, hwndc, HWND, , TScrollBox%A_Index%, ahk_id %hwnd%
		If hwndc = 
			Break
		hwndp := DllCall("GetParent", "UInt", hwndc)
		WinGetClass, class, ahk_id %hwndp%
		If class = TPanel
		{
			return hwndc
		}
	}
	return
}

AfxSuspendMessageWindow(hwnd = 0)
{
	AfxFixArg1(hwnd)
	hwndc := _AfxGetMessageWindow(hwnd)
	; WM_SETREDRAW, FALSE, 0
	If hwndc <>
		SendMessage, 11, 0, 0,, ahk_id %hwndc%
}

AfxResumeMessageWindow(hwnd = 0)
{
	AfxFixArg1(hwnd)
	hwndc := _AfxGetMessageWindow(hwnd)
	; WM_SETREDRAW, TRUE, 0
	If hwndc <>
	{
		SendMessage, 11, 1, 0,, ahk_id %hwndc%
		DllCall("InvalidateRect", "UInt", hwndc, "UInt", 0, "UInt", 1)
	}
}

_GetApplicationWindow()
{
	Prev_TitleMatchMode := A_TitleMatchMode
	Prev_DetectHiddenWindows := A_DetectHiddenWindows

	SetTitleMatchMode 2
	DetectHiddenWindows On
	hwnd:=WinExist(A_ScriptName . " ahk_class AutoHotkey")

	DetectHiddenWindows %Prev_DetectHiddenWindows%
	SetTitleMatchMode %Prev_TitleMatchMode%

	return hwnd
}

_InjEnvDLL(arg)
{
	static module

	if arg
	{
		module := DllCall("LoadLibrary", "Str", "injenv.dll")
		return module
	}
	else
	{
		return DllCall("FreeLibrary", "UInt", module)
	}
}

_LoadInjEnvDLL()
{
	return _InjEnvDLL(1)
}

_UnloadInjEnvDLL()
{
	return _InjEnvDLL(0)
}

AfxIsMinimized(hwnd = 0)
{
	AfxFixArg1(hwnd)

	WinGet, state, MinMax, ahk_id %hwnd%
	If(state = -1)
		return true

	WinGet, pid, PID, ahk_id %hwnd%
	WinGet, state, MinMax, ahk_pid %pid% ahk_class TApplication
	If(state = -1) {
		return true
	}

	return false
}

AfxRestore(hwnd = 0)
{
	AfxFixArg1(hwnd)

	WinGet, state, MinMax, ahk_id %hwnd%
; Not Activated
	If(state = -1) {
		WinRestore, ahk_id %hwnd%
	}

; Activated
	WinGet, pid, PID, ahk_id %hwnd%
	WinGet, state, MinMax, ahk_pid %pid% ahk_class TApplication
	If(state = -1) {
		WinRestore, ahk_pid %pid% ahk_class TApplication
	}
}

AfxMinimize(hwnd = 0)
{
	AfxFixArg1(hwnd)

	WinGet, pid, PID, ahk_id %hwnd%
	WinGet, hwndApp, ID, ahk_pid %pid% ahk_class TApplication
	WinGetTitle, title, ahk_id %hwndApp%

	If(title="") {
		WinMinimize, ahk_id %hwnd%
	} Else {
		WinMinimize, ahk_pid %pid% ahk_class TApplication
	}
}

