#Include afxctrl2.ahk
#Include afxscript2.ahk

DetectHiddenWindows, On

inifile=%A_ScriptDir%\tafx.ini

FRAMEWIDTH:=DllCall("GetSystemMetrics", "Int", 32, "Int") ; SM_CXSIZEFRAME
FRAMEHEIGHT:=DllCall("GetSystemMetrics", "Int", 33, "Int") ; SM_CYSIZEFRAME
SIZE=20

IniRead, AfxPath, %inifile%, tafx, AfxPath
IniRead, width, %inifile%, tafx, Width, +0
IniRead, height, %inifile%, tafx, Height, +0
IniRead, tabs, %inifile%, tafx, Tabs, 4
IniRead, place, %inifile%, tafx, Place, Left
IniRead, modifier, %inifile%, tafx, Modifier, !
IniRead, last, %inifile%, tafx, LastTab, 1

If(tabs < 1 || tabs>9) {
	MsgBox, Tabs  2 ȏ 9 ȉ̒lw肵ĂB
	ExitApp
}

Loop, %tabs%
{
	IniRead, name%A_Index%, %inifile%, tafx, Name%A_Index%, %A_Index%

	IniRead, lpath%A_Index%, %inifile%, tafx, LPath%A_Index%, %A_Space%
	IniRead, lsort%A_Index%, %inifile%, tafx, LSort%A_Index%, %A_Space%
	IniRead, lmask%A_Index%, %inifile%, tafx, LMask%A_Index%, %A_Space%

	IniRead, rpath%A_Index%, %inifile%, tafx, RPath%A_Index%, %A_Space%
	IniRead, rsort%A_Index%, %inifile%, tafx, RSort%A_Index%, %A_Space%
	IniRead, rmask%A_Index%, %inifile%, tafx, RMask%A_Index%, %A_Space%
}

If(AfxWindow() = 0) {
	Run, %AfxPath%
	Loop 10 {
		Sleep, 1000
		If(AfxWindow() <> 0) {
			Break
		}
	}
	If(AfxWindow() = 0) {
		MsgBox, ӂ̋NmFł܂łB
		ExitApp
	}
}
hwndAfx:=AfxWindow()
WinGet, pid, PID, ahk_id %hwndAfx%
WinGet, hwndApp, ID, ahk_pid %pid% ahk_class TApplication

Gui, Margin, 0, 0
Gui, Add, Button, x0 y0 w%SIZE% h%SIZE% gClose, x
args=
Loop, %tabs%
{
	If A_Index=1
		args:=name%A_Index%
	Else
		args:=args . "|" . name%A_Index%
}
taboption:=CreateTabOption(hwndAfx, place, width, height)
Gui, Add, Tab2, %taboption% Buttons AltSubmit -Wrap gTabChange vtab HwndhwndTab +0x4000 Choose%last%,%args%
SendMessage, 0x1300+45, 0, 0, ,  ahk_id %hwndTab% ; TCM_GETTOOLTIPS
hwndTt:=ErrorLevel
WinSet, Style, +1, ahk_id %hwndTt% ; TTS_ALWAYSTIP
WinSet, AlwaysOnTop, On, ahk_id %hwndTt%
; I'm not sure the reason but removing +Resize causes no effect of bringing to top
; Dynamically setting has also effect.
Gui, -MaximizeBox -MinimizeBox -SysMenu -Caption +Resize
winoption:=CreateWinOption(hwndAfx, place)
Gui, Show, %winoption%
Gui, +LastFound
hwndTafx:=WinExist()
OnExit, AtExit
OnMessage(78, "WM_NOTIFY")
OnMessage(6, "Transfer")
OnMessage(0x9000+6, "WM_ACTIVATE")
AfxRegisterOnMessage("AfxEvent")

HotKey, %modifier%0, AltMenu
Loop, %tabs%
{
	HotKey, %modifier%%A_Index%, AltKey
}

Transfer(wParam,lParam,msg,hwnd)
{
	global hwndTafx
	PostMessage, msg+0x9000, %wParam%, %lParam%, , ahk_id %hwndTafx%
}

UpdateAfxWindow()
{
	local hwnd
	if(isDestroy) {
		WinGet, hwnd, ID, ahk_pid %pid% ahk_class TAfxForm
		If(hwnd="") {
			WinGet, hwnd, ID, ahk_pid %pid% ahk_class TAfxWForm
		}
		If(hwnd<>"") {
			hwndAfx:=hwnd
			AfxWindow(hwndAfx)
			isDestroy = false
		}
	}
}

; TCHITTESTINFO
;   POINT pt;   0
;     LONG x;   0
;     LONG y;   4
;   UINT flags; 8

; NMHDR hdr;
;   HWND hwndFrom;   0
;   UINT_PTR idFrom; 4
;   UINT code;       8
; LPTSTR lpszText;   12
; TCHAR szText[80];  16
; HINSTANCE hinst;   176
; LPARAM lParam;     180

WM_NOTIFY(wParam,lParam,msg,hwnd)
{
	local hwndCtrl, hittest, index, str ; Assume-global mode
	static wstr
	If(NumGet(0+lParam, 8) = 0xfffffdee) {
		hwndCtrl:=NumGet(0+lParam, 0)
		SendMessage,1048,0,300,,ahk_id %hwndCtrl%
		VarSetCapacity(hittest, 12)
		DllCall("GetCursorPos", "UInt", &hittest, "UInt")
		DllCall("ScreenToClient", "UInt", hwndTab, "UInt", &hittest, "UInt")
		SendMessage,0x130d,0,&hittest,,ahk_id %hwndTab%
		index:=ErrorLevel+1
		str:=lpath%index% . "|" . lsort%index% . "|" . lmask%index% . "`r`n" . rpath%index% . "|" . rsort%index% . "|" . rmask%index%
		A2W(wstr, str)
		NumPut(&wstr, lParam+12)
	}
	; empty return value has meaning
	return
}

WM_ACTIVATE(wParam,lParam,msg,hwnd)
{
	global hwndAfx, hwndTafx
	UpdateAfxWindow()
	Critical
	state:=wParam & 0xFFFF
	minimized:=wParam >> 16
OutputDebug, WM_ACTIVATE state %state% minimized %minimized% hwnd %lParam% - A %hwndAfx% T %hwndTafx%
	If(minimized = 0 && state <> 0) {
		WinSet, AlwaysOnTop, On, ahk_id %hwndAfx%
		WinSet, Top, , ahk_id %hwndAfx%
		WinSet, AlwaysOnTop, Off, ahk_id %hwndAfx%

		AfxRestore(hwndAfx)
	}
	; empty return value has meaning
	return
}

AfxEvent(wParam,lParam,msg,hwndTo,hwndFrom)
{
	local taboption, winoption
OutputDebug, AfxEvent %hwndFrom% %hwndTo% %msg% %wParam% %lParam%
	UpdateAfxWindow()
	Critical
	If(hwndFrom <> hwndAfx && hwndFrom <> hwndApp) {
		return
	}
	If(msg = 0x8001 && lParam <> 0x83008300 || msg == 0x8002 && wParam <> 1 || msg == 0x8003 && (wParam >> 16) == 0 && (wParam & 0xFFFF) <> 0) {
		WinSet, AlwaysOnTop, On, ahk_id %hwndTafx%
		WinSet, Top, , ahk_id %hwndTafx%
		WinSet, AlwaysOnTop, Off, ahk_id %hwndTafx%
		taboption:=CreateTabPosOption(hwndAfx, place, width, height)
		GuiControl, Move, tab, %taboption%
		winoption:=CreateWinOption(hwndAfx, place)
		Gui, Show, NoActivate AutoSize
		Gui, Show, NoActivate %winoption%
	} Else If(msg == 0x8002 && wParam == 1) {
		Gui, Show, Minimize
	} Else If(msg == 0x8004) {
OutputDebug, AfxEvent Destroy1
		isDestroy = true
		If(select<>"" && WinExist("ahk_id " . hwndAfx))
		{
			lpath%select%:=AfxPathLWin()
			rpath%select%:=AfxPathRWin()
			lsort%select%:=AfxSortStatusLWin()
			rsort%select%:=AfxSortStatusRWin()
			lmask%select%:=AfxMaskLWin()
			rmask%select%:=AfxMaskRWin()
			IniWrite, %select%, %inifile%, tafx, LastTab
		}
	} Else If(msg == 0x8005) {
OutputDebug, AfxEvent Destroy2
		Gui, Destroy
; The above "Gui, Destroy" does not call GuiClose:, why?
		ExitApp
	}
}

HandleRelative(window, arg)
{
	StringLeft, arg1, arg, 1
	If(arg1="+" || arg1="-") {
		StringTrimLeft, arg2, arg, 1
		If(arg1="+") {
			return window+arg2
		} Else {
			return window-arg2
		}
	} Else {
		return arg
	}
}

CreateTabPosOption(hwnd, place, width, height)
{
	local w,h,option
	WinGetPos, , , w, h, ahk_id %hwnd%
	width:=HandleRelative(w, width)-SIZE-FRAMEWIDTH
	height:=HandleRelative(h, height)-SIZE-FRAMEHEIGHT
	If(place="left" || place="right") {
		If(height="" || height<0) {
			option=x0 y%SIZE% w%SIZE%
		} else {
			option=x0 y%SIZE% w%SIZE% h%height%
		}
	} Else If(place="top" || place="bottom") {
		If(width="" || width<0) {
			option=x%SIZE% y0 h%SIZE%
		} else {
			option=x%SIZE% y0 w%width% h%SIZE%
		}
	} Else {
		option=CreateTabPosOption(hwnd, "left", width, height)
	}
	return option
}

CreateTabOption(hwnd, place, width, height)
{
	option:=CreateTabPosOption(hwnd, place, width, height) . " " . place
	return option
}

CreateWinOption(hwnd, place)
{
	local x,y,w,h,option
	WinGetPos, x, y, w, h, ahk_id %hwnd%
	If(place="left") {
		x:=x-SIZE-FRAMEWIDTH
		option=x%x% y%y% w%SIZE%
	} Else If(place="right") {
		x:=x+w
		option=x%x% y%y% w%SIZE%
	} Else If(place="top") {
		y:=y-SIZE-FRAMEHEIGHT
		option=x%x% y%y% h%SIZE%
	} Else If(place="bottom") {
		y:=y+h
		option=x%x% y%y% h%SIZE%
	} Else {
		option=CreateWinOption(hwnd, "left")
	}
	return option
}

TabChange:
UpdateAfxWindow()
GuiControlGet, select,, tab
If tab<>
{
	lpath%tab%:=AfxPathLWin()
	rpath%tab%:=AfxPathRWin()
	lsort%tab%:=AfxSortStatusLWin()
	rsort%tab%:=AfxSortStatusRWin()
	lmask%tab%:=AfxMaskLWin()
	rmask%tab%:=AfxMaskRWin()
}
command=
If lpath%select%<>
{
	lpath:=lpath%select% . "\"
	command=%command% -L"%lpath%"
}
If rpath%select%<>
{
	rpath:=rpath%select% . "\"
	command=%command% -R"%rpath%"
}
If lsort%select%<>
{
	lsort:=lsort%select%
	command=%command% -SL"%lsort%"
}
If rsort%select%<>
{
	rsort:=rsort%select%
	command=%command% -SR"%rsort%"
}
If lmask%select%<>
{
	lmask:=lmask%select%
	command=%command% -*L"%lmask%"
}
If rsort%select%<>
{
	rmask:=rmask%select%
	command=%command% -*R"%rmask%"
}
If command<>
{
	AfxExCd(command)
}
Gui, Show, Restore
WinActivate, ahk_id %hwndAfx%
Return

AltKey:
StringTrimLeft, newtab, A_ThisHotkey, 1
Gui,Submit,NoHide
GuiControl,Choose,tab,|%newtab%
GoSub,TabChange
Return

AltMenu:
UpdateAfxWindow()
str=
Loop, %tabs%
{
	index:=A_Index
	AfxAddMessage(index . "L: " . lpath%index% . "|" . lsort%index% . "|" . lmask%index%)
	AfxAddMessage(index . "R: " . rpath%index% . "|" . rsort%index% . "|" . rmask%index%)
}
Return

Close:
Gui,Destroy

GuiClose:
UpdateAfxWindow()
OutputDebug, GuiClose
If(select<>"" && WinExist("ahk_id " . hwndAfx))
{
	lpath%select%:=AfxPathLWin()
	rpath%select%:=AfxPathRWin()
	lsort%select%:=AfxSortStatusLWin()
	rsort%select%:=AfxSortStatusRWin()
	lmask%select%:=AfxMaskLWin()
	rmask%select%:=AfxMaskRWin()
	IniWrite, %select%, %inifile%, tafx, LastTab
}
ExitApp

AtExit:
AfxUnregisterOnMessage()
Loop, %tabs%
{
	value:=lpath%A_Index%
	IniWrite, %value%, %inifile%, tafx, LPath%A_Index%
	value:=lsort%A_Index%
	IniWrite, %value%, %inifile%, tafx, LSort%A_Index%
	value:=lmask%A_Index%
	IniWrite, %value%, %inifile%, tafx, LMask%A_Index%

	value:=rpath%A_Index%
	IniWrite, %value%, %inifile%, tafx, RPath%A_Index%
	value:=rsort%A_Index%
	IniWrite, %value%, %inifile%, tafx, RSort%A_Index%
	value:=rmask%A_Index%
	IniWrite, %value%, %inifile%, tafx, RMask%A_Index%
}
ExitApp
