;
;   afxscript2.ahk: Helper library for AutoHotkey to control Afx
;
;       Copyright (c) Yak! 2007-2008 All rights reserved.
;

#Include afxctrl.ahk

#Include encutil.ahk

AfxAddMessage(hwnd, message = 0)
{
    AfxFixArg2(hwnd, message)
    _LoadInjEnvDLL()
    DllCall("injenv.dll\InstallInjectEnvHook")
    DllCall("injenv.dll\InjectMessageA", "UInt", hwnd, "Str", message)
    DllCall("injenv.dll\UninstallInjectEnvHook")
    _UnloadInjEnvDLL()
}
AfxSendCommand(hwnd, command = 0)
{
    AfxFixArg2(hwnd, command)
    _LoadInjEnvDLL()
    DllCall("injenv.dll\InstallInjectEnvHook")
    DllCall("injenv.dll\InjectCommandA", "UInt", hwnd, "Str", command)
    DllCall("injenv.dll\UninstallInjectEnvHook")
    _UnloadInjEnvDLL()
}

AfxSendCommandU(hwnd, command = 0)
{
    AfxFixArg2(hwnd, command)
    U2W(command_, command)
    _LoadInjEnvDLL()
    DllCall("injenv.dll\InstallInjectEnvHook")
    DllCall("injenv.dll\InjectCommandW", "UInt", hwnd, "Str", command_)
    DllCall("injenv.dll\UninstallInjectEnvHook")
    _UnloadInjEnvDLL()
}
AfxFilenameOn(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$F")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxBasenameOn(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$W")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxExtentionOn(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$E")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxPathCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$P")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxPathOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$O")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxPathLWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$L")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxPathRWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$R")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFilenameOn(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$f")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortBasenameOn(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$w")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortPathCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$p")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortPathOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$o")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortPathLWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$l")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortPathRWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$r")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxSortStatusCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$SP")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxSortStatusOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$SO")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxSortStatusLWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$SL")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxSortStatusRWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$SR")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxFilenameMarked(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$MS")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxFilenameMarkedCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$MS")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxFullpathMarked(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$MF")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxFullpathMarkedCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$MF")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxFullpathMarkedOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$mO")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFilenameMarked(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$Ms")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFilenameMarkedCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$Ms")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFullpathMarked(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$Mf")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFullpathMarkedCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$Mf")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxShortFullpathMarkedOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$QN$JT$mo")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxMaskCWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$*P")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxMaskOWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$*O")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxMaskLWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$*L")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxMaskRWin(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$*R")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxExecPath(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$V""afx""")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar0(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$0")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar1(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$1")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar2(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$2")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar3(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$3")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar4(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$4")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar5(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$5")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar6(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$6")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar7(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$7")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar8(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$8")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxVar9(hwnd = 0)
{
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x$9")
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxGetVariable(hwnd, var = 0)
{
    AfxFixArg2(hwnd, var)
    ClipSaved := ClipboardAll
    AfxSendCommand(hwnd, "&CLIP x" var)
    Result := Clipboard
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}

AfxGetVariableU(hwnd, var = 0)
{
    AfxFixArg2(hwnd, var)
    ClipSaved := ClipboardAll
    AfxSendCommandU(hwnd, "&CLIP x" . var)
    Transform, Result, Unicode
    Clipboard := ClipSaved
    ClipSaved =
    StringTrimLeft, Result, Result, 1
    return Result
}
AfxNop(hwnd = 0)
{
    AfxSendCommand(hwnd, "&NOP")
}
AfxReload(hwnd = 0)
{
    AfxSendCommand(hwnd, "&RELOAD")
}
AfxExec(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EXEC" " " arg)
}
AfxOpen(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&OPEN" " " arg)
}
AfxWavPlay(hwnd = 0)
{
    AfxSendCommand(hwnd, "&WAVPLAY")
}
AfxWavStop(hwnd = 0)
{
    AfxSendCommand(hwnd, "&WAVSTOP")
}
AfxContext(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CONTEXT" " " arg)
}
AfxExtract(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EXTRACT" " " arg)
}
AfxV_Arc(hwnd = 0)
{
    AfxSendCommand(hwnd, "&V_ARC")
}
AfxSusie(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&SUSIE" " " arg)
}
AfxS_Arc(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&S_ARC" " " arg)
}
AfxCd(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CD" " " arg)
}
AfxExCd(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EXCD" " " arg)
}
AfxMask(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&MASK" " " arg)
}
AfxMark(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&MARK" " " arg)
}
AfxSort(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&SORT" " " arg)
}
AfxClip(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CLIP" " " arg)
}
AfxMesClip(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MESCLIP")
}
AfxMax(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MAX")
}
AfxMin(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MIN")
}
AfxPushd(hwnd = 0)
{
    AfxSendCommand(hwnd, "&PUSHD")
}
AfxPopd(hwnd = 0)
{
    AfxSendCommand(hwnd, "&POPD")
}
AfxSet(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&SET" " " arg)
}
AfxCopyTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&COPYTO" " " arg)
}
AfxMoveTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&MOVETO" " " arg)
}
AfxMeltTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&MELTTO" " " arg)
}
AfxCopyHis(hwnd = 0)
{
    AfxSendCommand(hwnd, "&COPYHIS")
}
AfxMoveHis(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MOVEHIS")
}
AfxLDropTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&LDROPTO" " " arg)
}
AfxRDropTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&RDROPTO" " " arg)
}
AfxWDropTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&WDROPTO" " " arg)
}
AfxDivide(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&DIVIDE" " " arg)
}
AfxConnect(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CONNECT" " " arg)
}
AfxCcTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CCTO" " " arg)
}
AfxCmTo(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&CMTO" " " arg)
}
AfxView(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&VIEW" " " arg)
}
AfxEdit(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EDIT" " " arg)
}
AfxPrpty(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&PRPTY" " " arg)
}
AfxTow(hwnd = 0)
{
    AfxSendCommand(hwnd, "&TOW")
}
AfxMks_U(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MKS_U")
}
AfxMks_D(hwnd = 0)
{
    AfxSendCommand(hwnd, "&MKS_D")
}
AfxEject(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EJECT" " " arg)
}
AfxEach(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EACH" " " arg)
}
AfxEachNw(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&EACHNW" " " arg)
}
AfxRegRen(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&REGREN" " " arg)
}
AfxReld_Rd(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&RELD_RD" " " arg)
}
AfxVspMv(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&VSPMV" " " arg)
}
AfxHspMv(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&HSPMV" " " arg)
}
AfxMenu(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&MENU" " " arg)
}
AfxPMenu(hwnd, arg = 0)
{
    AfxFixArg2(hwnd, arg)
    AfxSendCommand(hwnd, "&PMENU" " " arg)
}
